       SUBROUTINE FFT2(NR,A,N,IS,LAB)
       PARAMETER(ND=256,ND2=ND/2)
       COMMON/WORK/D(ND),COSI(ND2),IREV(ND2)
       DIMENSION A(NR,1)
       M=N/2
       L=M+1
       K=N+2
       Z=1./N
       CALL TRIG(N)
       IF(LAB.LT.0)GOTO 5
       CALL PERM(M)
       DO 2 J=1,N
       DO 1 I=1,N
 1     D(I)=A(I,J)
       CALL FOUR(N,M,IS)
       CALL FXR1(N,IS)
       DO 2 I=1,K
 2     A(I,J)=Z*D(I)
       CALL PERM(N)
       DO 4 J=1,L
       JI=2*J
       JR=JI-1
       DO 3 I=1,N
       II=2*I
       IR=II-1
       D(IR)=A(JR,I)
 3     D(II)=A(JI,I)
       CALL FOUR(N,N,IS)
       DO 4 I=1,N
       II=2*I
       IR=II-1
       A(JR,I)=D(IR)
 4     A(JI,I)=D(II)
       IF(LAB.GT.0)RETURN
 5     CALL PERM(N)
       DO 7 J=1,L
       JI=2*J
       JR=JI-1
       DO 6 I=1,N
       II=2*I
       IR=II-1
       D(IR)=A(JR,I)
 6     D(II)=A(JI,I)
       CALL FOUR(N,N,-IS)
       DO 7 I=1,N
       II=2*I
       IR=II-1
       A(JR,I)=D(IR)
 7     A(JI,I)=D(II)
       CALL PERM(M)
       DO 9 J=1,N
       DO 8 I=1,K
 8     D(I)=Z*A(I,J)
       CALL FXR2(N,-IS)
       CALL FOUR(N,M,-IS)
       DO 9 I=1,N
 9     A(I,J)=D(I)
       RETURN
       END
       SUBROUTINE PERM(N)
       PARAMETER(ND=256,ND2=ND/2)
       COMMON/WORK/D(ND),COSI(ND2),IREV(ND2)
       DO 1 I=1,N
 1     IREV(I)=I
       J=1
       DO 4 I=1,N
       IF(I.GE.J)GOTO 2
       IREV(I)=J
       IREV(J)=I
 2     M=N/2
 3     IF(J.LE.M)GOTO 4
       J=J-M
       M=M/2
       IF(M.GE.2)GOTO 3
 4     J=J+M
       RETURN
       END
       SUBROUTINE TRIG(N)
       PARAMETER(ND=256,ND2=ND/2)
       COMMON/WORK/D(ND),COSI(ND2),IREV(ND2)
       THETA=4.*ATAN(1.)/N
       DO 1 I=1,N,2
       THI=(I-1)*THETA
       COSI(I)=COS(THI)
 1     COSI(I+1)=SIN(THI)
       RETURN
       END
       SUBROUTINE FOUR(N,M,IS)
       PARAMETER(ND=256,ND2=ND/2)
       COMMON/WORK/D(ND),COSI(ND2),IREV(ND2)
       DO 1 K=1,M
       I1=2*K
       J1=2*IREV(K)
       IF(I1.GE.J1)GOTO 1
       I=I1-1
       J=J1-1
       TR=D(J)
       TI=D(J1)
       D(J)=D(I)
       D(J1)=D(I1)
       D(I)=TR
       D(I1)=TI
 1     CONTINUE
       IMAX=2*M
       KMAX=2
 2     IF(KMAX.GE.IMAX)RETURN
       ISTEP=2*KMAX
       KFAC=N/KMAX
       DO 3 K=1,KMAX,2
       J=(K-1)*KFAC+1
       WR=COSI(J)
       WI=COSI(J+1)*IS
       DO 3 I=K,IMAX,ISTEP
       J=I+KMAX
       I1=I+1
       J1=J+1
       TR=WR*D(J)-WI*D(J1)
       TI=WR*D(J1)+WI*D(J)
       D(J)=D(I)-TR
       D(J1)=D(I1)-TI
       D(I)=D(I)+TR
 3     D(I1)=D(I1)+TI
       KMAX=ISTEP
       GOTO 2
       END
       SUBROUTINE FXR1(N,IS)
       PARAMETER(ND=256,ND2=ND/2)
       COMMON/WORK/D(ND),COSI(ND2),IREV(ND2)
       IMAX=N/2+1
       D(N+1)=D(1)
       D(N+2)=D(2)
       K=N+2
       DO 1 I=1,IMAX,2
       J=K-I
       I1=I+1
       J1=J+1
       WR=COSI(I)
       WI=COSI(I1)*IS
       ZR=(1.-WI)*.5
       ZI=.5*WR
       DIFR=D(I)-D(J)
       DIFI=D(I1)+D(J1)
       TR=ZR*DIFR-ZI*DIFI
       TI=ZR*DIFI+ZI*DIFR
       D(I)=D(I)-TR
       D(I1)=D(I1)-TI
       IF(I.EQ.J)RETURN
       D(J)=D(J)+TR
 1     D(J1)=D(J1)-TI
       END
       SUBROUTINE FXR2(N,IS)
       PARAMETER(ND=256,ND2=ND/2)
       COMMON/WORK/D(ND),COSI(ND2),IREV(ND2)
       IMAX=N/2+1
       K=N+2
       DO 1 I=1,IMAX,2
       J=K-I
       I1=I+1
       J1=J+1
       WR=COSI(I)
       WI=COSI(I1)*IS
       ZR=(1.+WI)*.5
       ZI=-.5*WR
       DIFR=D(I)-D(J)
       DIFI=D(I1)+D(J1)
       TR=ZR*DIFR-ZI*DIFI
       TI=ZR*DIFI+ZI*DIFR
       D(I)=(D(I)-TR)*2.
       D(I1)=(D(I1)-TI)*2.
       IF(I.EQ.J)RETURN
       D(J)=(D(J)+TR)*2.
 1     D(J1)=(D(J1)-TI)*2.
       END
       SUBROUTINE CNTR(NR,A,N,IX,IY,SKY)
       PARAMETER(ND=256,ND2=ND/2)
       COMMON/WORK/D(ND),COSI(ND2),IREV(ND2)
       DIMENSION A(NR,1)
       LOGICAL IL,JL
       L=N/16
       M=N-L+1
       S=0.
       P=0.
       DO 1 J=1,N
       JL=J.GT.L.AND.J.LT.M
       DO 1 I=1,N
       IL=I.GT.L.AND.I.LT.M
       IF(JL.AND.IL)GOTO 1
       S=S+A(I,J)
       P=P+1.
 1     CONTINUE
       SKY=S/P
       S=0.
       DO 2 J=1,N
       DO 2 I=1,N
       A(I,J)=A(I,J)-SKY
 2     S=AMAX1(A(I,J),S)
       S=S/2.
       P=0.
       XC=0.
       YC=0.
       DO 3 J=1,N
       DO 3 I=1,N
       IF(A(I,J).LT.S)GOTO 3
       Q=A(I,J)-S
       XC=XC+Q*I
       YC=YC+Q*J
       P=P+Q
 3     CONTINUE
       XC=XC/P
       YC=YC/P
       IX=INT(XC+.5)
       IY=INT(YC+.5)
       K=N-IX
       DO 5 J=1,N
       DO 4 I=1,N
 4     D(I)=A(I,J)
       DO 5 I=1,N
       II=MOD(K+I,N)+1
 5     A(II,J)=D(I)
       K=N-IY
       DO 7 I=1,N
       DO 6 J=1,N
 6     D(J)=A(I,J)
       DO 7 J=1,N
       JJ=MOD(K+J,N)+1
 7     A(I,JJ)=D(J)
       RETURN
       END
       SUBROUTINE SHFT(NR,A,N,IC)
       PARAMETER(ND=256,ND2=ND/2)
       COMMON/WORK/D(ND2),COSI(ND2),IREV(ND2)
       COMPLEX A,D
       DIMENSION A(NR,1)
       L=N/2+1
       M=N-IC
       DO 2 J=1,L
       DO 1 I=1,N
 1     D(I)=A(J,I)
       DO 2 I=1,N
       II=MOD(M+I,N)+1
 2     A(J,I)=D(II)
       RETURN
       END
       SUBROUTINE DCTR(NR,A,N,IX,IY)
       PARAMETER(ND=256,ND2=ND/2)
       COMMON/WORK/D(ND),COSI(ND2),IREV(ND2)
       DIMENSION A(NR,1)
       K=N-IX
       DO 2 J=1,N
       DO 1 I=1,N
 1     D(I)=A(I,J)
       DO 2 I=1,N
       II=MOD(K+I,N)+1
 2     A(I,J)=D(II)
       K=N-IY
       DO 4 I=1,N
       DO 3 J=1,N
 3     D(J)=A(I,J)
       DO 4 J=1,N
       JJ=MOD(K+J,N)+1
 4     A(I,J)=D(JJ)
       RETURN
       END
