      program test
      implicit none
      integer*2 line(512)
      integer id1, id2, i, j, istat, itype, npix, nlin
      integer imopen_, imwin_, imcopy_, ihdrcp_
      character *40 image1, image2, image3, trunc
      character *60 object
      print 10
  10  format('Enter input image: ', $)
      read 20, image1
  20	format(a40)
      print 30
  30  format('Enter output image: ', $)
      read 20, image2
      print 35
  35  format('Enter header name: ', $)
      read 20, image3
c	This subroutine/function should always be called before
c	any reference is made to images
      call ibegin_
c	Open image for read-only. Remember to truncate name with char(0).
      id1 = imopen_(trunc(image1), 0, itype, npix, nlin)
      if (id1 .lt. 0) then
        print *, 'cannot open image1'
        stop
      end if
c	Get name of object
      call igobj_(trunc(image1), len(object), object)
      print *, 'type = ', itype
      print *, 'npix = ', npix
      print *, 'nlin = ', nlin
      print *, 'object = ', object
      print *, ' '
      print *, ' '
      pause
c	Define a 10 x 10 window with upper left corner at (100, 100)
      istat = imwin_(id1, 100, 100, 10, 10)
      if (istat .le. 0) then
        print *, 'window outside image1'
        stop
      end if
      do 40 j = 1, 10
c	Read a line from window. Lines are numbered: 0, 1, 2,...
        call imgetl_(id1, j - 1, line)
        print 50, (line(i), i = 1, 10)
  40  continue
  50  format(10i7)
      print *, ' '
      print *, ' '
c	Copy image1 to image2
      id2 = imcopy_(trunc(image1), trunc(image2), 2, 1)
      if (id2 .lt. 0) then
        print *, 'cannot copy: image1 -> image2'
        stop
      end if
c	Close image1
      call mclose_(id1)
c	Define a 10 x 10 window with upper left corner at (100, 100)
      istat = imwin_(id2, 100, 100, 10, 10)
      if (istat .le. 0) then
        print *, 'window outside image2'
        stop
      end if
      do 60 j = 1, 10
c	Read a line from window. Lines are numbered: 0, 1, 2,...
        call imgetl_(id2, j - 1, line)
        print 50, (line(i), i = 1, 10)
  60  continue
c	Close image
      call mclose_(id2)
c	This subroutine should always be called before exit
      if (ihdrcp_(trunc(image1), trunc(image3)) .ne. 0) then
        print *, 'Error in ihdrcp_'
        stop
      end if
      call iend_
      end
c	Function which terminates character string with char(0)
c	as required by C.
      character*40 function trunc(text)
      character *(*) text
      do 100 i = len(text), 1, -1
        if (text(i:i) .ne. ' ') goto 110
 100  continue
 110  i = i + 1
      text(i:i) = char(0)
      trunc = text
      return
      end
