
/**************************************************************************/
/*                                                                        */
/*   This program is free software; you can redistribute it and/or modify */
/*   it under the terms of the GNU General Public License as published by */
/*   the Free Software Foundation; either version 2 of the License, or    */
/*   (at your option) any later version.                                  */
/*                                                                        */
/*   This program is distributed in the hope that it will be useful,      */
/*   but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*   GNU General Public License for more details.                         */
/*                                                                        */
/*   You should have received a copy of the GNU General Public License    */
/*   along with this program; if not, write to the                        */
/*       Free Software Foundation, Inc.,                                  */
/*       59 Temple Place, Suite 330,                                      */
/*       Boston, MA  02111-1307                                           */
/*       USA                                                              */
/*                                                                        */
/**************************************************************************/
#define	FB1CNT0	0x500	/* Lower Byte of Pixel Counter */
#define	FB1CNT1	0x501	/* Middle Byte of Pixel Counter */
#define	FB1CNT2	0x502	/* Upper Byte of Pixel Counter */
#define	FB1PREG	0x503	/* Write Only Page Register */
/*--------------------------------------------------------------------*/
#define	FB2CNT0	0x510	/* Lower Byte of Pixel Counter */
#define	FB2CNT1	0x511	/* Middle Byte of Pixel Counter */
#define	FB2CNT2	0x512	/* Upper Byte of Pixel Counter */
#define	FB2PREG	0x513	/* Write Only Page Register */
/*--------------------------------------------------------------------*/
#define	PAG_SIZ	65536L	/* page size in bytes */
#define	RAM_PAG	32	/* pages per 2MB frame buffer RAM */
/*--------------------------------------------------------------------*/
#if	defined(MSC)	/* MS-C */
#define	FB1SEG	0xd000	/* base paragraph of frame buffer 1 */
#define	FB2SEG	0xe000	/* base paragraph of frame buffer 2 */
#define	FB1OFF	0x0000	/* base offset of frame buffer 1 */
#define	FB2OFF	0x0000	/* base offset of frame buffer 2 */
#endif
/*--------------------------------------------------------------------*/
#if	defined(HC1) || defined(HC2) || defined(WC)
/* High-C or WATCOM-C 9.0/386 */
#define	FB1SEG	0x34	/* segment that maps the first Mb of RAM */
#define	FB2SEG	0x34
#define	FB1OFF	0xd0000	/* base offset of frame buffer 1 */
#define	FB2OFF	0xe0000	/* base offset of frame buffer 2 */
#endif
/*--------------------------------------------------------------------*/
#if	defined(SYSV) || defined(BSD)	/* Linux */
#define FB1OFF	0xd0000	/* base offset of frame buffer 1 */
#define FB2OFF	0xd0000	/* base offset of frame buffer 2 */
#endif
/*--------------------------------------------------------------------*/
extern void ccd_off(const int frame);
extern void ccd_on(const int frame);
extern long get_cnt(const int frame);
extern void put_cnt(const int frame, const long cnt);
extern void set_fwin(const int frame, const int page);
extern void close_map(void);
extern void map_fram(int pag_buf);
/*--------------------------------------------------------------------*/
#if	defined(MSC)	/* MS-C */
extern char far *fb1_win[];
extern char far *fb2_win[];
#endif
/*--------------------------------------------------------------------*/
#if	defined(HC1) || defined(HC2)	/* High-C */
extern _far volatile char *fb1_win[];
extern _far volatile char *fb2_win[];
#endif
/*--------------------------------------------------------------------*/
#if	defined(WC)	/* WATCOM-C 9.0/386 */
#if	defined(DOS4G)	/* Rational Systems DOS/4GW */
extern volatile char *fb1_win[];
extern volatile char *fb2_win[];
#else	/* Phar Lap 386|DOS-Extender */
extern volatile char __far *fb1_win[];
extern volatile char __far *fb2_win[];
#endif
#endif
/*--------------------------------------------------------------------*/
#if	defined(SYSV) || defined(BSD)	/* Linux */
extern volatile char *fb1_win[];
extern volatile char *fb2_win[];
#endif
