
/**************************************************************************/
/*                                                                        */
/*   This program is free software; you can redistribute it and/or modify */
/*   it under the terms of the GNU General Public License as published by */
/*   the Free Software Foundation; either version 2 of the License, or    */
/*   (at your option) any later version.                                  */
/*                                                                        */
/*   This program is distributed in the hope that it will be useful,      */
/*   but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*   GNU General Public License for more details.                         */
/*                                                                        */
/*   You should have received a copy of the GNU General Public License    */
/*   along with this program; if not, write to the                        */
/*       Free Software Foundation, Inc.,                                  */
/*       59 Temple Place, Suite 330,                                      */
/*       Boston, MA  02111-1307                                           */
/*       USA                                                              */
/*                                                                        */
/**************************************************************************/
/* prototypes for median functions */
#if	defined(ANSI)	/* ANSI-C */
extern void medi_uchar(UCHAR buf[], const UCHAR *arr[], const float weight[],
      const int nimg, const int npix, const double limit);
extern int rmed_uchar(UCHAR buf[], const int y, const UCHAR *arr[],
		const int nrows, const int ncols, const int my, const int mx,
		const double limit);
extern void medi_short(short buf[], const short *arr[], const float weight[],
      const int nimg, const int npix, const double limit,
      const double blank);
extern int rmed_short(short buf[], const int y, const short *arr[],
		const int nrows, const int ncols, const int my, const int mx,
		const double limit, const double blank);
extern void medi_long(LONG buf[], const LONG *arr[], const float weight[],
      const int nimg, const int npix, const double limit,
      const double blank);
extern int rmed_long(LONG buf[], const int y, const LONG *arr[],
		const int nrows, const int ncols, const int my, const int mx,
		const double limit, const double blank);
extern float fmedian(const int n, const float a[], float w[]);
extern void medi_float(float buf[], const float *arr[], const float weight[],
      const int nimg, const int npix, const double limit,
      const double blank);
extern int rmed_float(float buf[], const int y, const float *arr[],
		const int nrows, const int ncols, const int my, const int mx,
		const double limit, const double blank);
#else	/* old style */
extern void medi_uchar();
extern int rmed_uchar();
extern void medi_short();
extern int rmed_short();
extern void medi_long();
extern int rmed_long();
extern float fmedian();
extern void medi_float();
extern int rmed_float();
#endif
