
/**************************************************************************/
/*                                                                        */
/*   This program is free software; you can redistribute it and/or modify */
/*   it under the terms of the GNU General Public License as published by */
/*   the Free Software Foundation; either version 2 of the License, or    */
/*   (at your option) any later version.                                  */
/*                                                                        */
/*   This program is distributed in the hope that it will be useful,      */
/*   but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*   GNU General Public License for more details.                         */
/*                                                                        */
/*   You should have received a copy of the GNU General Public License    */
/*   along with this program; if not, write to the                        */
/*       Free Software Foundation, Inc.,                                  */
/*       59 Temple Place, Suite 330,                                      */
/*       Boston, MA  02111-1307                                           */
/*       USA                                                              */
/*                                                                        */
/**************************************************************************/
#if	defined(ANSI)	/* ANSI-C */
extern char *nrerror(const char *error_text);
extern int *ivector(int nl, int nh);
extern float *vector(int nl, int nh);
extern double *dvector(int nl, int nh);
extern COMPLEX *cvector(int nl, int nh);
extern int **imatrix(int nrl, int nrh, int ncl, int nch);
extern float **matrix(int nrl, int nrh, int ncl, int nch);
extern float **fmatrix(int nrl, int nrh, int ncl, int nch);
extern double **dmatrix(int nrl, int nrh, int ncl, int nch);
extern COMPLEX **cmatrix(int nrl, int nrh, int ncl, int nch);
extern void free_ivector(int *v, int nl);
extern void free_vector(float *v, int nl);
extern void free_dvector(double *v, int nl);
extern void free_cvector(COMPLEX *v, int nl);
extern void free_imatrix(int **m, int nrl, int ncl);
extern void free_matrix(float **m, int nrl, int ncl);
extern void free_dmatrix(double **m, int nrl, int ncl);
extern void free_cmatrix(COMPLEX **m, int nrl, int ncl);
extern void fourn(float data[], const int nn[],
	const int ndim, const int isign);
extern void tridiag(const double a[], const double b[],
	const double c[], const double r[], int n, double u[]);
extern char *nakspl(const double x[], const double y[], int n, double z[]);
extern char *spline(const double x[], const double y[], int n,
	double yp1, double ypn, double y2[]);
extern double splint(const double xa[], const double ya[],
	const double y2a[], int n, double x);
extern char *akima(const double x[], const double y[], int n, double z[]);
extern double akint(const double xa[], const double ya[], const double z[],
	int n, double x);
extern char *gaussj(double *a[], int n, double *b[], int m);
extern void covsrt(double *covar[], int ma, const int lista[], int mfit);
extern char *mrq2cof(float * const *z, float blank, double skymean,
	double skyvar, double epdu, int ixc, int iyc, int irad,
	const double a[], int ma, const int lista[], int mfit, int *npt,
	double *alpha[], double beta[], double *chisq,
	void (*funcs)(int, int, const double a[], double *z, double dzda[]));
extern char *mrq2min(float * const *z, float blank, double skymean,
	double skyvar, double epdu, int ixc, int iyc, int irad,
	double a[], int ma, int lista[], int mfit, int *npt,
	double *covar[], double *alpha[], double *chisq,
	void (*funcs)(int, int, const double a[], double *z, double dzda[]),
	double *alamda);
extern void gauss2(int x, int y, const double a[], double *z, double dzda[]);
extern char *g2fit(float * const *image, float blank, double epdu,
	int irad1, int irad2, int irad3, double *xc, double *yc,
	double *fwhm, double *dxc, double *dyc, double *dfwhm);
extern char *mrq1cof(const float *z, float blank, double skymean,
	double skyvar, double epdu, int ixc, int irad, const double a[],
	int ma, const int lista[], int mfit, int *npt,
	double *alpha[], double beta[], double *chisq,
	void (*funcs)(int, const double a[], double *z, double dzda[]));
extern char *mrq1min(const float *z, float blank, double skymean,
	double skyvar, double epdu, int ixc, int irad,
	double a[], int ma, int lista[], int mfit, int *npt,
	double *covar[], double *alpha[], double *chisq,
	void (*funcs)(int, const double a[], double *z, double dzda[]),
	double *alamda);
extern void gauss1(int x, const double a[], double *z, double dzda[]);
extern char *g1xfit(float * const *image, float blank, double epdu,
	int ix1, int ix2, int ix3, double *xc, double *yc,
	double *fwhm, double *dxc, double *dfwhm);
extern char *g1yfit(float * const *image, float blank, double epdu,
	int iy1, int iy2, int iy3, double *xc, double *yc,
	double *fwhm, double *dyc, double *dfwhm);
extern char *mrq3cof(float * const *z, float blank, double skymean,
	double skyvar, double epdu, int ixc, int iyc, int irad,
	const double a[], int ma, const int lista[], int mfit, int *npt,
	double *alpha[], double beta[], double *chisq,
	void (*funcs)(int, int, const double a[], double *z, double dzda[], int));
extern char *mrq3min(float * const *z, float blank, double skymean,
	double skyvar, double epdu, int ixc, int iyc, int irad,
	double a[], int ma, int lista[], int mfit, int *npt,
	double *covar[], double *alpha[], double *chisq,
	void (*funcs)(int, int, const double a[], double *z, double dzda[], int),
	double *alamda);
extern void gauss3(int x, int y,
	const double a[], double *z, double dzda[], int na);
extern char *g3fit(float * const *image, float blank, double epdu,
	int irad1, int irad2, int irad3, double *a1, double *r1,
	double *a2, double *r2, double *xc, double *yc);
extern char *mrq4cof(COMPLEX * const *z, double blank, double var,
	int uc, int vc, int rad, const double a[], int ma, const int lista[],
	int mfit, int *npt, double *alpha[], double beta[], double *chisq,
	void (*funcs)(int, int, const double a[], COMPLEX *z, COMPLEX dzda[]));
extern char *mrq4min(COMPLEX * const *z, double blank, double var,
	int uc, int vc, int rad, double a[], int ma, int lista[], int mfit,
	int *npt, double *covar[], double *alpha[], double *chisq,
	void (*funcs)(int, int, const double a[], COMPLEX *z, COMPLEX dzda[]),
	double *alamda);
extern void otf2d(int u, int v, const double a[],
	COMPLEX *z, COMPLEX dzda[]);
extern char *g4fit(COMPLEX * const *otf, double blank,
	int uc, int vc, int r1, int r2, int r3, double *gam,
	double *pow, double *a2, double *b2, double *dgam,
	double *dpow, double *da2, double *db2);
#else	/* old style */
extern char *nrerror();
extern int *ivector();
extern float *vector();
extern double *dvector();
extern COMPLEX *cvector();
extern int **imatrix();
extern float **matrix();
extern float **fmatrix();
extern double **dmatrix();
extern COMPLEX **cmatrix();
extern void free_ivector();
extern void free_vector();
extern void free_dvector();
extern void free_cvector();
extern void free_imatrix();
extern void free_matrix();
extern void free_dmatrix();
extern void free_cmatrix();
extern void fourn();
extern void tridiag();
extern char *nakspl();
extern char *spline();
extern double splint();
extern char *akima();
extern double akint();
extern char *gaussj();
extern void covsrt();
extern char *mrq2cof();
extern char *mrq2min();
extern void gauss2();
extern char *g2fit();
extern char *mrq1cof();
extern char *mrq1min();
extern void gauss1();
extern char *g1xfit();
extern char *g1yfit();
extern char *mrq3cof();
extern char *mrq3min();
extern void gauss3();
extern char *g3fit();
extern char *mrq4cof();
extern char *mrq4min();
extern void otf2d();
extern char *g4fit();
#endif
