
/**************************************************************************/
/*                                                                        */
/*   This program is free software; you can redistribute it and/or modify */
/*   it under the terms of the GNU General Public License as published by */
/*   the Free Software Foundation; either version 2 of the License, or    */
/*   (at your option) any later version.                                  */
/*                                                                        */
/*   This program is distributed in the hope that it will be useful,      */
/*   but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*   GNU General Public License for more details.                         */
/*                                                                        */
/*   You should have received a copy of the GNU General Public License    */
/*   along with this program; if not, write to the                        */
/*       Free Software Foundation, Inc.,                                  */
/*       59 Temple Place, Suite 330,                                      */
/*       Boston, MA  02111-1307                                           */
/*       USA                                                              */
/*                                                                        */
/**************************************************************************/
#include "host.h"	/* defines MSC, HC1, HC2, WC, BSD or SYSV */
#include <stdio.h>
/*----------------------------------------------------------------------*/
#include "nonansi.h"	/* const and void redefined if not ANSI-C */
#include "bufsiz.h"	/* function declarations for bufsiz.c */
/*----------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
int msb(unsigned x)
#else	/* old style */
int msb(x)	/* position of most significant bit */
unsigned x;
#endif
{
	int n;
	for (n = -1; x ; n++)
		x >>= 1;
	return(n);	/* returns -1 if x = 0 */
}
/*----------------------------------------------------------------------*/
static int BufLen = -1;	/* Buffer size = 2**BufLen */
/*----------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
void setbufsiz(unsigned size)
#else	/* old style */
void setbufsiz(size)	/* set stream buffer size */
unsigned size;
#endif
{
		if (BUF_SIZ != 0)	/* change buffer block size if BUF_SIZ != 0 */
			BufLen = msb(size);	/* Buffer size = 2**BufLen */
		else
			BufLen = msb(BUFSIZ);
}
/*----------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
unsigned buffsize(void)
#else	/* old style */
unsigned buffsize()	/* block size */
#endif
{
	if (BufLen < 0)	/* BufLen has not been initialized */
		setbufsiz(BUF_SIZ);	/* initialize BufLen */
	return (1 << BufLen);	/* return the buffer block size in bytes */
}
/*----------------------------------------------------------------------*/
