
/**************************************************************************/
/*                                                                        */
/*   This program is free software; you can redistribute it and/or modify */
/*   it under the terms of the GNU General Public License as published by */
/*   the Free Software Foundation; either version 2 of the License, or    */
/*   (at your option) any later version.                                  */
/*                                                                        */
/*   This program is distributed in the hope that it will be useful,      */
/*   but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*   GNU General Public License for more details.                         */
/*                                                                        */
/*   You should have received a copy of the GNU General Public License    */
/*   along with this program; if not, write to the                        */
/*       Free Software Foundation, Inc.,                                  */
/*       59 Temple Place, Suite 330,                                      */
/*       Boston, MA  02111-1307                                           */
/*       USA                                                              */
/*                                                                        */
/**************************************************************************/
#include "host.h"	/* defines MSC, HC1, HC2, WC, BSD or SYSV */
#include <stdio.h>
#include <stdlib.h>
/*--------------------------------------------------------------------*/
#if	defined(HC1)	/* High-C V1.6 */
#include <msdos.cf>
#endif
#if	defined(MSC) || defined(HC2) || defined(WC)
/* MS-C, High-C V2.3, or WATCOM-C 9.0/386 */
#include <dos.h>
#include <conio.h>
#endif
#if	defined(SYSV) || defined(BSD)	/* Linux */
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <asm/io.h>
#endif
/*--------------------------------------------------------------------*/
#include "exitret.h"	/* define EXIT values, if not defined */
#include "nonansi.h"	/* const and void redefined if not ANSI-C */
#include "bufsiz.h"	/* function declarations for bufsiz.c */
#include "fbuf.h"	/* constants and prototypes for fbuf.c */
/*--------------------------------------------------------------------*/
#define	PAG_BUF	64	/* maximum number of blocks per page */
/*--------------------------------------------------------------------*/
#if	defined(MSC)	/* MS-C or Zortech-C */
#if	defined(FP_SEG)
#undef	FP_SEG
#endif
#if	defined(FP_OFF)
#undef	FP_OFF
#endif
#define FP_SEG(fp) (*((unsigned *)&(fp) + 1))
#define FP_OFF(fp) (*((unsigned *)&(fp)))
#endif
/*--------------------------------------------------------------------*/
#if	defined(HC1)	/* High-C V1.6 */
typedef struct {	/* _far pointer */
	UINT off;
	USHORT seg;
} OVERLAY;
#define FP_SEG(fp) ((OVERLAY *)&(fp))->seg	/* segment selector */
#define FP_OFF(fp) ((OVERLAY *)&(fp))->off	/* 32-bit offset */ 
#endif
/*--------------------------------------------------------------------*/
#if	defined(WC)	/* WATCOM-C 9.0/386 */
#if	defined(FP_SEG)
#undef	FP_SEG
#endif
#if	defined(FP_OFF)
#undef	FP_OFF
#endif
#define FP_SEG(farptr) (*(unsigned short *)((unsigned *)&(farptr) + 1))
#define FP_OFF(farptr) (*((unsigned *)&(farptr)))
#endif
/*--------------------------------------------------------------------*/
typedef union {	/* pixel counter type */
	struct {UCHAR L, M, H, X;} B;
	ULONG C;
} COUNTER;
/*--------------------------------------------------------------------*/
void ccd_off(	/* disable serial port */
const int frame)	/* frame buffer number */
{
#if	defined(MSC) || defined(WC)	/* MS-C or WATCOM-C 9.0/386 */
	switch (frame) {
		case 1:
			outp(FB1PREG, 0x0);	/* disable serial port */
			break;
		case 2:
			outp(FB2PREG, 0x0);	/* disable serial port */
			break;
		default:
			break;
	}
#endif
#if	defined(HC1) || defined(HC2)	/* High-C */
	switch (frame) {
		case 1:
			_outb(FB1PREG, 0x0);	/* disable serial port */
			break;
		case 2:
			_outb(FB2PREG, 0x0);	/* disable serial port */
			break;
		default:
			break;
	}
#endif
#if	defined(SYSV) || defined(BSD)	/* Linux */
	switch (frame) {
		case 1:
			outb_p((char)0x0, (USHORT)FB1PREG);
			break;
		case 2:
			outb_p((char)0x0, (USHORT)FB2PREG);
		default:
			break;
	}
#endif
}
/*--------------------------------------------------------------------*/
void ccd_on(	/* enable serial port */
const int frame)	/* frame buffer number */
{
#if	defined(MSC) || defined(WC)	/* MS-C or WATCOM-C 9.0/386 */
	switch (frame) {
		case 1:
			outp(FB1PREG, 0x80);	/* enable serial port */
			break;
		case 2:
			outp(FB2PREG, 0x80);	/* enable serial port */
			break;
		default:
			break;
	}
#endif
#if	defined(HC1) || defined(HC2)	/* High-C */
	switch (frame) {
		case 1:
			_outb(FB1PREG, 0x80);	/* enable serial port */
			break;
		case 2:
			_outb(FB2PREG, 0x80);	/* enable serial port */
			break;
		default:
			break;
	}
#endif
#if	defined(SYSV) || defined(BSD)	/* Linux */
	switch (frame) {
		case 1:
			outb_p((char)0x80, (USHORT)FB1PREG);
			break;
		case 2:
			outb_p((char)0x80, (USHORT)FB2PREG);
			break;
		default:
			break;
	}
#endif
}
/*--------------------------------------------------------------------*/
long get_cnt(	/* get pixel counter */
const int frame)	/* frame buffer number */
{
	COUNTER x;
	x.C = 0L;
#if	defined(MSC) || defined(WC)	/* MS-C or WATCOM-C 9.0/386 */
	switch (frame) {
		case 1:	/* get pixel counter for frame buffer 1 */
			x.B.L = (UCHAR)inp(FB1CNT0);	/* read lower byte */
			x.B.M = (UCHAR)inp(FB1CNT1);	/* read middle byte */
			x.B.H = (UCHAR)inp(FB1CNT2);	/* read upper byte */
			break;
		case 2:	/* get pixel counter for frame buffer 2 */
			x.B.L = (UCHAR)inp(FB2CNT0);	/* read lower byte */
			x.B.M = (UCHAR)inp(FB2CNT1);	/* read middle byte */
			x.B.H = (UCHAR)inp(FB2CNT2);	/* read upper byte */
			break;
		default:
			break;
	}
#endif
#if	defined(HC1) || defined(HC2)	/* High-C */
	switch (frame) {
		case 1:	/* get pixel counter for frame buffer 1 */
			x.B.L = _inb(FB1CNT0);	/* read lower byte */
			x.B.M = _inb(FB1CNT1);	/* read middle byte */
			x.B.H = _inb(FB1CNT2);	/* read upper byte */
			break;
		case 2:	/* get pixel counter for frame buffer 2 */
			x.B.L = _inb(FB2CNT0);	/* read lower byte */
			x.B.M = _inb(FB2CNT1);	/* read middle byte */
			x.B.H = _inb(FB2CNT2);	/* read upper byte */
			break;
		default:
			break;
	}
#endif
#if	defined(SYSV) || defined(BSD)	/* Linux */
	switch (frame) {
		case 1:	/* get pixel counter for frame buffer 1 */
			x.B.L = (UCHAR)inb_p((USHORT)FB1CNT0);
			x.B.M = (UCHAR)inb_p((USHORT)FB1CNT1);
			x.B.H = (UCHAR)inb_p((USHORT)FB1CNT2);
			break;
		case 2:	/* get pixel counter for frame buffer 2 */
			x.B.L = (UCHAR)inb_p((USHORT)FB2CNT0);
			x.B.M = (UCHAR)inb_p((USHORT)FB2CNT1);
			x.B.H = (UCHAR)inb_p((USHORT)FB2CNT2);
			break;
		default:
			break;
	}
#endif
	return x.C;
}
/*--------------------------------------------------------------------*/
void put_cnt(	/* set pixel counter */
const int frame,	/* frame buffer number */
const long cnt)	/* pixel counter */
{
	COUNTER x;
	x.C = cnt;	/* load pixel counter */
#if	defined(MSC) || defined(WC)	/* MS-C or WATCOM-C 9.0/386 */
	switch (frame) {
		case 1:	/* set pixel counter for frame buffer 1 */
			outp(FB1CNT0, x.B.L);	/* write lower byte */
			outp(FB1CNT1, x.B.M);	/* write middle byte */
			outp(FB1CNT2, x.B.H);	/* write upper byte */
			break;
		case 2:	/* set pixel counter for frame buffer 2 */
			outp(FB2CNT0, x.B.L);	/* write lower byte */
			outp(FB2CNT1, x.B.M);	/* write middle byte */
			outp(FB2CNT2, x.B.H);	/* write upper byte */
			break;
		default:
			break;
	}
#endif
#if	defined(HC1) || defined(HC2)	/* High-C */
	switch (frame) {
		case 1:	/* set pixel counter for frame buffer 1 */
			_outb(FB1CNT0, x.B.L);	/* write lower byte */
			_outb(FB1CNT1, x.B.M);	/* write middle byte */
			_outb(FB1CNT2, x.B.H);	/* write upper byte */
			break;
		case 2:	/* set pixel counter for frame buffer 2 */
			_outb(FB2CNT0, x.B.L);	/* write lower byte */
			_outb(FB2CNT1, x.B.M);	/* write middle byte */
			_outb(FB2CNT2, x.B.H);	/* write upper byte */
			break;
		default:
			break;
	}
#endif
#if	defined(SYSV) || defined(BSD)	/* Linux */
	switch (frame) {
		case 1:	/* set pixel counter for frame buffer 1 */
			outb_p(x.B.L, (USHORT)FB1CNT0);	/* write lower byte */
			outb_p(x.B.M, (USHORT)FB1CNT1);	/* write middle byte */
			outb_p(x.B.H, (USHORT)FB1CNT2);	/* write upper byte */
			break;
		case 2:	/* set pixel counter for frame buffer 2 */
			outb_p(x.B.L, (USHORT)FB2CNT0);	/* write lower byte */
			outb_p(x.B.M, (USHORT)FB2CNT1);	/* write middle byte */
			outb_p(x.B.H, (USHORT)FB2CNT2);	/* write upper byte */
			break;
		default:
			break;
	}
#endif
}
/*--------------------------------------------------------------------*/
void set_fwin(	/* select window page for fb#_win[PAG_BLK][BLK_SIZ] */
const int frame,	/* frame buffer number */
const int page)	/* window page number */
{
#if	defined(MSC) || defined(WC)	/* MS-C or WATCOM-C 9.0/386 */
	switch (frame) {
		case 1:	/* select page for fb1_win[][] */
			outp(FB1PREG, page);
			break;
		case 2:	/* select page for fb2_win[][] */
			outp(FB2PREG, page);
			break;
		default:
			break;
	}
#endif
#if	defined(HC1) || defined(HC2)	/* High-C */
	switch (frame) {
		case 1:	/* select page for fb1_win[][] */
			_outb(FB1PREG, page);
			break;
		case 2:	/* select page for fb2_win[][] */
			_outb(FB2PREG, page);
			break;
		default:
			break;
	}
#endif
#if	defined(SYSV) || defined(BSD)	/* Linux */
	switch (frame) {
		case 1:	/* select page for fb1_win[][] */
			outb_p((char)page, (USHORT)FB1PREG);
			break;
		case 2:	/* select page for fb2_win[][] */
			outb_p((char)page, (USHORT)FB2PREG);
			break;
		default:
			break;
	}
#endif
}
/*--------------------------------------------------------------------*/
#if	defined(MSC)	/* MS-C */
char far *fb1_win[PAG_BUF] = {(char far *)0};
char far *fb2_win[PAG_BUF] = {(char far *)0};
#endif
/*--------------------------------------------------------------------*/
#if	defined(HC1) || defined(HC2)	/* High-C */
_far volatile char *fb1_win[PAG_BUF] = {(_far char *)0};
_far volatile char *fb2_win[PAG_BUF] = {(_far char *)0};
#endif
/*--------------------------------------------------------------------*/
#if	defined(WC)	/* WATCOM-C 9.0/386 */
#if	defined(DOS4G)	/* Rational Systems DOS/4GW */
volatile char *fb1_win[PAG_BUF] = {(char *)0};
volatile char *fb2_win[PAG_BUF] = {(char *)0};
#else	/* Phar Lap 386|DOS-Extender */
volatile char __far *fb1_win[PAG_BUF] = {(char __far *)0};
volatile char __far *fb2_win[PAG_BUF] = {(char __far *)0};
#endif
#endif
/*--------------------------------------------------------------------*/
#if	defined(SYSV) || defined(BSD)	/* Linux */
volatile char *fb1_win[PAG_BUF] = {(char *)0};
volatile char *fb2_win[PAG_BUF] = {(char *)0};
static int mem_fd = 0;
static char *mem_buf = (char *)0;
#endif
/*--------------------------------------------------------------------*/
void close_map(void)
{
#if	defined(SYSV) || defined(BSD)	/* Linux */
	if (munmap((caddr_t)mem_buf, PAG_SIZ) != 0) {
		fprintf(stderr, "close_map: munmap error\n");
		exit(EXIT_FAILURE);
	}
	free(mem_buf);
	if (close(mem_fd) != 0) {
		fprintf(stderr, "close_map: Can't close /dev/mem\n");
		exit(EXIT_FAILURE);
	}
#endif
}
/*--------------------------------------------------------------------*/
void map_fram(int pag_buf)	/* Assigns fb1_win[] and fb2_win[] */
{
	int i;
	unsigned bsize = buffsize();
	if (pag_buf > PAG_BUF) {
		fprintf(stderr,
			"map_fram: Too many blocks per page: %d\n", pag_buf);
		exit(EXIT_FAILURE);
	}
#if	defined(SYSV) || defined(BSD)	/* Linux */
	{
		int pgs = getpagesize();
		if ((mem_fd = open("/dev/mem", O_RDWR)) < 0) {
			fprintf(stderr,
				"map_fram: Can't open /dev/mem\n");
			exit(EXIT_FAILURE);
		}
		if ((mem_buf = malloc(PAG_SIZ + (pgs-1))) == NULL) {
			fprintf(stderr,
				"map_fram: Allocation error\n");
			exit(EXIT_FAILURE);
		}
		if ((unsigned long)mem_buf % pgs)
			mem_buf += pgs - ((unsigned long)mem_buf % pgs);
		mem_buf = (char *)mmap((caddr_t)mem_buf, PAG_SIZ,
			PROT_READ|PROT_WRITE, MAP_SHARED|MAP_FIXED,
			mem_fd, FB1OFF);
		if ((long)mem_buf < 0) {
			fprintf(stderr, "map_fram: mmap error\n");
			exit(EXIT_FAILURE);
		}
		fb1_win[0] = mem_buf;
		fb2_win[0] = mem_buf;
	}
#else
#if	defined(DOS4G)	/* Rational Systems DOS/4GW */
	fb1_win[0] = (char *) FB1OFF;
	fb2_win[0] = (char *) FB2OFF;
#else	/* otherwise a far pointer */
	FP_OFF(fb1_win[0]) = FB1OFF;
	FP_SEG(fb1_win[0]) = FB1SEG;
	FP_OFF(fb2_win[0]) = FB2OFF;
	FP_SEG(fb2_win[0]) = FB2SEG;
#endif
#endif
	for (i = 1; i < pag_buf; i++) {
		fb1_win[i] = fb1_win[i-1] + bsize;
		fb2_win[i] = fb2_win[i-1] + bsize;
	}
}
