
/**************************************************************************/
/*                                                                        */
/*   This program is free software; you can redistribute it and/or modify */
/*   it under the terms of the GNU General Public License as published by */
/*   the Free Software Foundation; either version 2 of the License, or    */
/*   (at your option) any later version.                                  */
/*                                                                        */
/*   This program is distributed in the hope that it will be useful,      */
/*   but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*   GNU General Public License for more details.                         */
/*                                                                        */
/*   You should have received a copy of the GNU General Public License    */
/*   along with this program; if not, write to the                        */
/*       Free Software Foundation, Inc.,                                  */
/*       59 Temple Place, Suite 330,                                      */
/*       Boston, MA  02111-1307                                           */
/*       USA                                                              */
/*                                                                        */
/**************************************************************************/
#include "host.h"	/* defines MSC, HC1, HC2, WC, BSD or SYSV */
/*--------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
#include <stdlib.h>	/* ANSI declarations */
#else	/* not ANSI-C */
#if	defined(BSD)	/* BSD-UNIX */
extern char *calloc();
extern char *malloc();
extern char *realloc();
#endif
#if	defined(SYSV)	/* UNIX System V */
extern void *calloc();
extern void *malloc();
extern void *realloc();
#endif
#endif
/*--------------------------------------------------------------------*/
#include "nonansi.h"	/* const and void redefined if not ANSI-C */
#include "matalloc.h"	/* function declarations for matalloc.c */
/*--------------------------------------------------------------------*/
#include "vmalloc.h"	/* function declarations for vmalloc.c */
#include "chkheap.h"	/* redefine malloc functions */
/*--------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
void *matalloc(unsigned nrows, unsigned ptsize,
	unsigned ncols, unsigned elsize, int *arows)
#else	/* old style */
void *matalloc(nrows, ptsize, ncols, elsize, arows)
unsigned nrows, ptsize, ncols, elsize;
int *arows;
#endif
{
	void **a;
	unsigned int i;
	*arows = 0;
	if ((a = (void **)calloc(nrows, ptsize)) == (void **)0)
		return (void *)a;	/* no space for pointer array */
	for (i = 0; i < nrows; i++)
		if ((a[i] = (void *)calloc(ncols, elsize)) == (void *)0)
			break;
		if (i == 0) {
			free(a);	/* free pointer array */
			return (void *)0;	/* no space for rows */
		}
		*arows = i;	/* number of rows allocated */
		return (void *)a;	/* return pointer to matrix */
}
/*--------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
void matfree(void *x, unsigned nrows)
#else	/* old style */
void matfree(x, nrows)
void *x;
unsigned nrows;
#endif
{
	void **a = (void **)x;
	int i = nrows;
	if (i > 0) {
		for (i--; i >= 0; i--)
			free(a[i]);	/* free allocated rows */
		free(x);	/* free pointer array */
	}
}
