
/**************************************************************************/
/*                                                                        */
/*   This program is free software; you can redistribute it and/or modify */
/*   it under the terms of the GNU General Public License as published by */
/*   the Free Software Foundation; either version 2 of the License, or    */
/*   (at your option) any later version.                                  */
/*                                                                        */
/*   This program is distributed in the hope that it will be useful,      */
/*   but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*   GNU General Public License for more details.                         */
/*                                                                        */
/*   You should have received a copy of the GNU General Public License    */
/*   along with this program; if not, write to the                        */
/*       Free Software Foundation, Inc.,                                  */
/*       59 Temple Place, Suite 330,                                      */
/*       Boston, MA  02111-1307                                           */
/*       USA                                                              */
/*                                                                        */
/**************************************************************************/
#include "host.h"	/* defines MSC, HC1, HC2, WC, BSD or SYSV */
#include <stdio.h>	/* declarations for stream I/O functions */
#include <string.h>	/* declarations for string functions */
#if	defined(ANSI)	/* ANSI-C */
#include <stdlib.h>
#else	/* not ANSI-C */
#if	defined(BSD)	/* BSD-UNIX */
extern char *calloc();
extern char *malloc();
extern char *realloc();
#endif
#if	defined(SYSV)	/* UNIX System V */
extern void *calloc();
extern void *malloc();
extern void *realloc();
#endif
#endif
/*--------------------------------------------------------------------*/
#include "exitret.h"	/* define EXIT values, if not defined */
#include "nonansi.h"	/* const and void redefined if not ANSI-C */
#include "imhdr.h"	/* function declarations for imhdr.c */
#include "imkw.h"	/* function declarations for imkw.c */
#include "imio.h"	/* function declarations for imio.c */
#include "args.h"	/* function declaration for args.c */
/*--------------------------------------------------------------------*/
char *punct = "!\"#%&\'()*+,-./:;<=>?[\\]^{|}~";
/*--------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
main(int Argc, char **Argv)
#else	/* old style */
main(Argc, Argv)
int Argc;
char **Argv;
#endif
{
	int argc;
	char **argv;
	int flag;
	char *image1, *image2;

#if	defined(ARGS)
	/* substitute some arguments (: or !) from previous command line */
	argv = args(Argc, Argv, &argc);
#else	/* no substitution */
	argc = Argc;
	argv = Argv;
#endif

	if (argc < 3) {
		printf("Usage: icp image1 image2\n");
		fflush(stdout);
		exit(EXIT_FAILURE);
	}

	image1 = truncname(argv[1]);
	if (strpbrk(image1, punct) != (char *)0) {
		fprintf(stderr, "icp: Illegal image name: %s\n", image1);
		exit(EXIT_FAILURE);
	}

	image2 = truncname(argv[2]);
	if (strpbrk(image2, punct) != (char *)0) {
		fprintf(stderr, "icp: Illegal image name: %s\n", image2);
		exit(EXIT_FAILURE);
	}

	/* read image names from header directory */
	if ((flag = prolog(0)) < 1) {	/* select first token in HDRPATH */
		fprintf(stderr, "icp: prolog: Error = %d\n", flag);
		exit(EXIT_FAILURE);
	}

	setipath(0);	/* select first token in IMGPATH */

	if (icopy(image1, image2, 0, 0) < 0) {
		fprintf(stderr, "icp: can't copy %s\n", image1);
		if (epilog() < 1)	/* update disk headers */
			fprintf(stderr, "icp: epilog: Disk header(s) not updated\n");
		exit(EXIT_FAILURE);
	}

	if (update() == 0)	/* update disk headers */
		fprintf(stderr, "icp: update: Disk header not created\n");

	sethistory(image2, "icp");
	sethistory(image2, image2);

	if (epilog() < 1) {	/* update disk headers */
		fprintf(stderr, "icp: epilog: Disk header(s) not updated\n");
		exit(EXIT_FAILURE);
	}

	fflush(stdout);
	exit(EXIT_SUCCESS);
}
