
/**************************************************************************/
/*                                                                        */
/*   This program is free software; you can redistribute it and/or modify */
/*   it under the terms of the GNU General Public License as published by */
/*   the Free Software Foundation; either version 2 of the License, or    */
/*   (at your option) any later version.                                  */
/*                                                                        */
/*   This program is distributed in the hope that it will be useful,      */
/*   but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*   GNU General Public License for more details.                         */
/*                                                                        */
/*   You should have received a copy of the GNU General Public License    */
/*   along with this program; if not, write to the                        */
/*       Free Software Foundation, Inc.,                                  */
/*       59 Temple Place, Suite 330,                                      */
/*       Boston, MA  02111-1307                                           */
/*       USA                                                              */
/*                                                                        */
/**************************************************************************/
#include "host.h"	/* defines MSC, HC1, HC2, WC, BSD or SYSV */
#include <stdio.h>	/* declarations for stream I/O functions */
#include <string.h>	/* declarations for string functions */
#if	defined(ANSI)	/* ANSI-C */
#include <stdlib.h>
#else	/* not ANSI-C */
#if	defined(BSD)	/* BSD-UNIX */
extern char *calloc();
extern char *malloc();
extern char *realloc();
#endif
#if	defined(SYSV)	/* UNIX System V */
extern void *calloc();
extern void *malloc();
extern void *realloc();
#endif
#endif
/*--------------------------------------------------------------------*/
#include "exitret.h"	/* define EXIT values, if not defined */
#include "nonansi.h"	/* const and void redefined if not ANSI-C */
#include "imhdr.h"	/* function declarations for imhdr.c */
#include "imkw.h"	/* function declarations for imkw.c */
#include "args.h"	/* function declaration for args.c */
/*--------------------------------------------------------------------*/
char *punct = "!\"#%&\'()*+,-./:;<=>?[\\]^{|}~";
/*--------------------------------------------------------------------*/
#if	defined(ANSI)	/* ANSI-C */
main(int Argc, char **Argv)
#else	/* old style */
main(Argc, Argv)
int Argc;
char **Argv;
#endif
{
	int argc;
	char **argv;
	char *image;
	int i;

#if	defined(ARGS)
	/* substitute some arguments (: or !) from previous command line */
	argv = args(Argc, Argv, &argc);
#else	/* no substitution */
	argc = Argc;
	argv = Argv;
#endif

	if(argc < 2) {
		printf("Usage: putkey image\n");
		printf("A test program which assigns all FITS keywords\n");
		fflush(stdout);
		exit(EXIT_FAILURE);
	}
	image = truncname(argv[1]);
	if (strpbrk(image, punct) != (char *)0) {
		fprintf(stderr, "putkey: Illegal image name: %s\n", image);
		exit(EXIT_FAILURE);
	}
	/* read image names from header directory */
	if ((i = prolog(0)) < 1) {	/* select first token in HDRPATH */
		fprintf(stderr, "putkey: prolog: Error = %d\n", i);
		exit(EXIT_FAILURE);
	}
	setsimple(image, 1);
	setbitpix(image, 16);
	setnaxis(image, 2);
	setnaxis1(image, 100);
	setnaxis2(image, 200);
	setbscale(image, 1.1111111);
	setbzero(image, 2.22222222);
	setbunit(image, "aaaaaaaaaaa");
	setblank(image, (double)(LONG_Min));
	setobject(image, "bbbbbbb");
	setdate(image);
	setdateobs(image);
	setorigin(image, "ccccccccccccc");
	setinstrume(image, "ddddddddd");
	settelescop(image, "eee");
	setobserver(image, "Bjarne");
	sethistory(image, "ffffff");
	setcrval1(image, 44.444444);
	setcrval2(image, 55.55555);
	setcrpix1(image, 666.);
	setcrpix2(image, 7777.);
	setcdelt1(image, 0.88888);
	setcdelt2(image, 9.99999999);
	setctype1(image, "ggggggg");
	setctype2(image, "hhhh");
	setcrota1(image, 1.11111111);
	setcrota2(image, 2.2222);
	setdatamax(image, 33333.);
	setdatamin(image, -4444.4);
	setepoch(image, 1989.0);
	setjdstart(image, 55555555.5);
	setjdstop(image, 666666666.6);
	setexptime(image, 500.5);
	setdarktime(image, 600.6);
	setiname(image);
	if (epilog() < 1) {	/* update disk headers */
		fprintf(stderr, "putkey: epilog: Disk header(s) not updated\n");
		exit(EXIT_FAILURE);
	}
	fflush(stdout);
	exit(EXIT_SUCCESS);
}
